public inbox for gentoo-dev@lists.gentoo.org
 help / color / mirror / Atom feed
* [gentoo-dev] RFC: USE flags in virtuals, to allow a specific provider to be determined
@ 2014-07-25 18:49 Ian Stakenvicius
  2014-07-25 19:04 ` Luis Ressel
                   ` (4 more replies)
  0 siblings, 5 replies; 39+ messages in thread
From: Ian Stakenvicius @ 2014-07-25 18:49 UTC (permalink / raw
  To: gentoo-dev

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Hey all..  So, putting aside for now how much of a mess this would be
to implement in the virtuals' ebuilds themselves, what do people think
of changing the virtuals so that they contain an entry in IUSE for
each provider that can satisfy it?

The idea here is that the package satisfying a virtual could be
optionally explicitly-chosen through package.use (or USE= in
make.conf, perhaps) instead of having an entry in @world, that way if
nothing depends on the virtual then it and the provider can be
- --depclean'ed from the system.  The idea is specifically NOT to have
rdeps depend on these flags, that would undermine the whole purpose of
the virtual; it would just be for end-users to set if they so chose.

This may also help with getting portage to peg a virtual's provider to
a specific package instead of constantly trying to switch from one to
another, ie, how systemd kept getting pulled in, in relation to the
upower virtual.  Note - I haven't done any tests to determine if this
actually helps with such issues tho (or even attempted to reproduce
them, as i was apparently one of the lucky ones that it didn't happen to).

I don't know if this would aid heavy binpkg users or not.


For completion, here's one of those rather messy examples:

- --- virtual/krb5-0.ebuild       2013-06-28 09:04:47.000000000 -0400
+++ virtual/krb5-0.ebuild.new   2014-07-25 14:47:48.000000000 -0400
@@ -2,7 +2,7 @@
 # Distributed under the terms of the GNU General Public License v2
 # $Header: /var/cvsroot/gentoo-x86/virtual/krb5/krb5-0.ebuild,v 1.2
2013/06/27 20:42:55 aballier Exp $

- -EAPI=3
+EAPI=5

 DESCRIPTION="Virtual for Kerberos V implementation"
 HOMEPAGE=""
@@ -11,7 +11,12 @@
 LICENSE=""
 SLOT="0"
 KEYWORDS="alpha amd64 arm hppa ia64 m68k ~mips ppc ppc64 s390 sh
sparc x86 ~amd64-fbsd ~amd64-linux ~x86-linux ~ppc-macos ~x86-macos"
- -IUSE=""
+IUSE="heimdal mit-krb5"

 DEPEND=""
- -RDEPEND="|| ( app-crypt/mit-krb5 app-crypt/heimdal )"
+RDEPEND="!mit-krb5? ( !heimdal? ( || ( app-crypt/mit-krb5
app-crypt/heimdal ) ) )
+       mit-krb5? ( app-crypt/mit-krb5 )
+       heimdal? ( app-crypt/heimdal )"
+
+REQUIRED_USE="heimdal? ( !mit-krb5 )
+       mit-krb5? ( !heimdal )"


Thoughts?
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v2

iF4EAREIAAYFAlPSpsgACgkQ2ugaI38ACPCBGwD6A7Dlras5l/L9Fc1SA8K8oR3K
LQKY5g/vbdvYFKtooDoBAKdLiFySl24mHKA0O2YScxmr4g5tvusVAd3dxWTIjnat
=gSFT
-----END PGP SIGNATURE-----


^ permalink raw reply	[flat|nested] 39+ messages in thread

end of thread, other threads:[~2014-07-29 11:06 UTC | newest]

Thread overview: 39+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2014-07-25 18:49 [gentoo-dev] RFC: USE flags in virtuals, to allow a specific provider to be determined Ian Stakenvicius
2014-07-25 19:04 ` Luis Ressel
2014-07-25 19:23   ` Ian Stakenvicius
2014-07-25 19:44     ` Luis Ressel
2014-07-25 19:46       ` Ciaran McCreesh
2014-07-25 19:49         ` Ian Stakenvicius
2014-07-25 19:51         ` Pacho Ramos
2014-07-25 19:54           ` Ian Stakenvicius
2014-07-25 20:12             ` Pacho Ramos
2014-07-25 20:18               ` Ciaran McCreesh
2014-07-26  8:28                 ` Pacho Ramos
2014-07-25 21:13               ` Ian Stakenvicius
2014-07-25 21:25                 ` Ciaran McCreesh
2014-07-25 21:23             ` William Hubbs
2014-07-25 21:25               ` Ciaran McCreesh
2014-07-25 21:46                 ` William Hubbs
2014-07-25 21:50                   ` Ciaran McCreesh
2014-07-26 17:45               ` [gentoo-dev] " Jonathan Callen
2014-07-27 15:38                 ` William Hubbs
2014-07-25 20:41 ` [gentoo-dev] " Michał Górny
2014-07-25 21:09   ` Ian Stakenvicius
2014-07-26  7:17     ` justin
2014-07-26  8:05 ` [gentoo-dev] " Duncan
2014-07-26  8:30   ` Pacho Ramos
2014-07-26  8:53   ` Michał Górny
2014-07-26  9:01     ` Duncan
2014-07-26 12:46     ` Ciaran McCreesh
2014-07-26  8:58   ` Duncan
2014-07-26 13:31   ` Ian Stakenvicius
2014-07-26 14:40 ` [gentoo-dev] " Manuel Rüger
2014-07-27 17:11   ` Peter Stuge
2014-07-28 14:20   ` Ian Stakenvicius
2014-07-28 14:42     ` Michał Górny
2014-07-28 15:11       ` Ian Stakenvicius
2014-07-28 11:21 ` Michał Górny
2014-07-28 17:02   ` Ian Stakenvicius
2014-07-29  4:23     ` James Potts
2014-07-29 11:06       ` Ciaran McCreesh
2014-07-29  4:51     ` Michał Górny

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox